#include <stdio.h>
#include <iostream>
#include <gmp.h>


int main(int argc, char* argv[]){
    
    mpz_t num;
    mpz_init(num);

    std::cout << "num | mpz_sizeinbase(num, (int)10)" << std::endl;
    for(int i = 1; i<1001; ++i){

        //generate char* of i
        std::string s = std::to_string(i);
        const char* c = s.c_str();

        // set num to i, using char*
        if(mpz_set_str(num, c, 10) == -1){
            std::cerr << "mpz_set_str failed\n";
            exit(EXIT_FAILURE);
        }

        //get digits of num
        size_t digits = mpz_sizeinbase(num, (int)10);

        //print num + digits
        std::cout << i << " | " << digits << std::endl;
    }

    mpz_clear(num);
}